Summary: BSD Compatibility Library for Darwin
Name: Libcompat
%define majver	14
%define minver	1
%define version %{majver}.%{minver}
Version: %{version}
Release: 13%{?dist}5a
Group: Development/Libraries
Source: http://www.opensource.apple.com/projects/darwin/1.3/source/apsl/%{name}-%{version}.tar.gz
Patch0: localhost/%{name}-%{version}-macosx10.6.patch
Patch1: localhost/%{name}-%{version}-macosx12.patch
License: Apple Public Source License
BuildRoot: %{_tmppath}/%{name}-root

BuildArch:      fat

%description
BSD compatibility library. 

%prep
%setup -q -c %{name}-%{version}
mv %{name}-%{majver}-%{minver} ARM64
pushd ARM64
%patch0 -p1 -b .macosx
%patch1 -p1 -b .macosx12
cp -f APPLE_LICENSE ..
popd
cp -a ARM64 X86_64

%build
pushd ARM64
make TARGET_ARCHS=arm64 MAKEFILEPATH=/Applications/Xcode.app/Contents/Developer/Makefiles \
WARNING_CFLAGS='-Wno-error=implicit-function-declaration'
popd

pushd X86_64
make TARGET_ARCHS=x86_64 MAKEFILEPATH=/Applications/Xcode.app/Contents/Developer/Makefiles \
WARNING_CFLAGS='-Wno-error=implicit-function-declaration'
popd


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT
PWD=`pwd`
pushd ARM64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
make TARGET_ARCHS=arm64 MAKEFILEPATH=/Applications/Xcode.app/Contents/Developer/Makefiles \
     DSTROOT="${PWD}-root" NEXTSTEP_INSTALLDIR=%{_prefix}/lib \
     PUBLIC_HDR_INSTALLDIR=%{_prefix}/include/compat \
     PRIVATE_HDR_INSTALLDIR=%{_prefix}/include/compat \
     install
popd

pushd X86_64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
make TARGET_ARCHS=x86_64 MAKEFILEPATH=/Applications/Xcode.app/Contents/Developer/Makefiles \
     DSTROOT="${PWD}-root" NEXTSTEP_INSTALLDIR=%{_prefix}/lib \
     PUBLIC_HDR_INSTALLDIR=%{_prefix}/include/compat \
     PRIVATE_HDR_INSTALLDIR=%{_prefix}/include/compat \
     install
popd

## Make Universal Binaries
filelist=$(find ./ARM64-root -type f | xargs file | sed -e 's,^\./ARM64-root/,,g' | \
        grep -E \(Mach-O\)\|\(ar\ archive\) |sed -e 's,:.*,,g' -e '/\for\ architecture/d')

for i in $filelist
do
        /usr/bin/lipo -create ARM64-root/$i X86_64-root/$i -output `basename $i` && \
        (cp -f `basename $i` ARM64-root/$i) || :
done

# check header files
for i in `find ARM64-root -name "*.h" -type f`
do
        TARGET=`echo $i | sed -e "s,.*ARM64-root,,"`
        TEMP=`diff -u ARM64-root/$TARGET X86_64-root/$TARGET > /dev/null || echo different`
        if [ -n "$TEMP" ]; then
                mv X86_64-root/$TARGET ARM64-root/${TARGET%.*}-x86_64.h
                mv ARM64-root/$TARGET ARM64-root/${TARGET%.*}-arm64.h
                FILE=${TARGET##*/}
                FILE=${FILE%.*}
cat <<EOF > ARM64-root/$TARGET
#if defined (__arm64__)
#include "${FILE}-arm64.h"
#elif defined( __x86_64__ )
#include "${FILE}-x86_64.h"
#endif
EOF
        fi
done

# install
mkdir -p %{buildroot}
tar cf - -C ARM64-root . | tar xpf - -C %{buildroot}


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,wheel)
%doc APPLE_LICENSE
%dir %{_prefix}/include/compat
%{_prefix}/include/compat/*.h
%{_prefix}/lib/libcompat.a

%changelog
* Fri Oct 27 2023 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-13hepx5a
- 2nd build and release on MacOS 13 now as fat binaries
- built with OSXWS 13

* Thu Oct 26 2023 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-13hepx4a
- 1st build and release on MacOS 13 for M2 Macs
- built with OSXWS 13

* Sat Feb 26 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-12hepx4b
- 2nd build and release on MacOS X Release 12 for M1 Macs
- built with OSXWS 12beta

* Thu Jan 27 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-12hepx4a
- 1st build and release on MacOS X Release 12 for M1 Macs
- built with OSXWS 11

* Wed Jan 22 2020 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.15hepx4a
- 1st build and release on MacOS X Release 10.15 for Intel Macs
- built with OSXWS 10.15

* Thu Dec 19 2019 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.14hepx4b
- 1st build and release on MacOS X Release 10.14 for Intel Macs
- built with OSXWS 10.14

* Mon Dec 24 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.14hepx4a
- 1st build and release on MacOS X Release 10.14 for Intel Macs
- MAKEFILEPATH added to make flags
- built with OSXWS 10.13

* Mon Apr 02 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.12hepx3a
- 1st build and release on MacOS X Release 10.13 for Intel Macs
- built with OSXWS 10.13

* Mon Dec 26 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.12hepx3b
- 2nd build and release on MacOS X Release 10.12 for Intel Macs
- built with OSXWS 10.12

* Sun Dec 18 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.12hepx3a
- 1st build and release on MacOS X Release 10.12 for Intel Macs
- built with OSXWS 10.11

* Mon Feb 08 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.11hepx3a
- 1st build and release on MacOS X Release 10.11 for Intel Macs
- now install headers to %{prefix}/include/compat

* Mon Dec 22 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.10hepx2a
- 1st build and release on MacOS X Release 10.10 for Intel Macs

* Wed Aug 06 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.9hepx2b
- 2nd build and release on MacOS X Release 10.9 for Intel Macs

* Tue Nov 19 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.9hepx2a
- 1st build and release on MacOS X Release 10.9 for Intel Macs

* Thu Sep 30 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.7hepx2a
- 1st release on MacOS X Release 10.7 for Intel Macs
- Now build for x86_64

* Thu Sep 30 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.6hepx1b
- 2nd release on MacOS X Release 10.6 for Intel Macs
- rebuilt with gcc-4.5.1

* Sat Mar  6 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.6hepx1a
- 1st release on MacOS X Release 10.6 for Intel Macs

* Thu Mar 20 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-10.5hepx1a
- 1st release on MacOS X Release 10.5 for Intel Macs

* Wed Apr 18 2007 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-2f
- 2nd release on MacOS X Release 10.4 for Intel Macs

* Fri Oct 06 2006 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-2e
- 1st release on MacOS X Release 10.4 for Intel Macs

* Wed May 18 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 14.1-2d
- 1st release on MacOS X Release 10.4

* Fri Jan 2 2004 Keisuke Fujii <keisuke.fujii@kek.jp>
- 1st release on MacOS X Release 10.3

* Wed Oct 9 2002 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- 1st release on MacOS X Release 10.2

* Wed Oct 10 2001 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- 1st release on MacOS X Release 10.1

* Fri Apr 20 2001 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- 1st release on MacOS X Release
